var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
(function(global, factory) {
  typeof exports === "object" && typeof module !== "undefined" ? factory(exports) : typeof define === "function" && define.amd ? define(["exports"], factory) : (global = typeof globalThis !== "undefined" ? globalThis : global || self, factory(global.vueModuleLoader = {}));
})(this, function(exports2) {
  "use strict";
  const moduleUninstallerMap = {};
  function uninstallCache(moduleName, uninstaller) {
    moduleUninstallerMap[moduleName] = uninstaller;
  }
  function listUnistaller() {
    return moduleUninstallerMap;
  }
  function uninstall(moduleName) {
    return __async(this, null, function* () {
      const app = window[Symbol.for("__GLOBAL_VUE_APP__")];
      moduleUninstallerMap[moduleName](app);
    });
  }
  function clear() {
    return __async(this, null, function* () {
      const app = window[Symbol.for("__GLOBAL_VUE_APP__")];
      for (let moduleName in moduleUninstallerMap) {
        moduleUninstallerMap[moduleName](app);
      }
    });
  }
  function loadStyle(moduleData, moduleHostUrl) {
    return new Promise((resolve, reject) => {
      const style = document.createElement("link");
      style.id = moduleData.name;
      style.rel = "stylesheet";
      style.crossOrigin = "anonymous";
      style.href = moduleHostUrl + "style.css";
      style.onload = () => {
        resolve();
      };
      style.onerror = () => {
        resolve();
      };
      document.head.append(style);
    });
  }
  function fireModule(moduleData, moduleHostUrl) {
    return __async(this, null, function* () {
      const context = window[Symbol.for("___VML_CONTEXT___")];
      let installReturn;
      try {
        console.log(`[vue-module-loader]: \u5F00\u59CB\u52A0\u8F7D\u6A21\u5757\u300C${moduleData.name}\u300D...`);
        if (moduleHostUrl) {
          yield loadStyle(moduleData, moduleHostUrl);
        }
        installReturn = yield moduleData.install(context);
        if (moduleData.uninstall)
          uninstallCache(moduleData.name, moduleData.uninstall);
        console.log(`[vue-module-loader]: \u6A21\u5757\u300C${moduleData.name}\u300D\u52A0\u8F7D\u5B8C\u6210`);
      } catch (error) {
        console.error(`[vue-module-loader]: \u6A21\u5757\u300C${moduleData.name}\u300D\u52A0\u8F7D\u9519\u8BEF`, error);
        installReturn = error;
      }
      return installReturn;
    });
  }
  function useModule(moduleData, Vue) {
    return __async(this, null, function* () {
      if (!window[Symbol.for("___VML_CONTEXT___")]) {
        if (!Vue) {
          throw new Error("[vue-module-loader]: \u672Ause\u63D2\u4EF6\u65F6\u4F7F\u7528useModule\u65B9\u6CD5\u8BF7\u5728\u7B2C\u4E8C\u4E2A\u53C2\u6570\u4F20\u5165Vue\u5168\u5C40\u5BF9\u8C61");
        } else {
          window[Symbol.for("___VML_CONTEXT___")] = { Vue };
        }
      }
      if (typeof moduleData === "object") {
        return yield fireModule(moduleData);
      } else if (typeof moduleData === "string") {
        const res = yield fetch(moduleData);
        const moduleString = yield res.text();
        const moduleCode = moduleString.replace("var", "return");
        const moduleStringFun = Function(`return function(vue){${moduleCode}}`)();
        const moduleDataFromUrl = moduleStringFun(window[Symbol.for("___VML_CONTEXT___")].Vue);
        return yield fireModule(moduleDataFromUrl, moduleData.match(/\S*\//)[0]);
      }
    });
  }
  function useContext(key) {
    if (!window[Symbol.for("___VML_CONTEXT___")])
      throw new Error("[vue-module-loader]: \u8BF7\u5148\u4F7F\u7528app.use\u65B9\u6CD5\u5B89\u88C5vue-module-loader\u63D2\u4EF6\u6216\u4F7F\u7528useModule\u65B9\u6CD5\u52A0\u8F7D\u4E00\u4E2A\u6A21\u5757\u3002");
    const target = window[Symbol.for("___VML_CONTEXT___")][key];
    if (target === void 0)
      throw new Error(`[vue-module-loader]\uFF1A\u4E0A\u4E0B\u6587\u4E2D\u4E0D\u5B58\u5728\u201C${key}\u201D`);
    return target;
  }
  function main(app, Vue) {
    var _a;
    if (!Vue) {
      throw new Error(`[vue-module-loader]: use\u63D2\u4EF6\u65F6\u5FC5\u987B\u4F20\u5165Vue\u5BF9\u8C61`);
    } else {
      if (!((_a = Vue.version) == null ? void 0 : _a.startsWith("3"))) {
        throw new Error(`[vue-module-loader]: \u672C\u63D2\u4EF6\u4EC5\u9002\u7528\u4E8Evue3`);
      } else {
        window[Symbol.for("___VML_CONTEXT___")] = {
          Vue
        };
        if (app) {
          window[Symbol.for("___VML_CONTEXT___")]["app"] = app;
        }
      }
    }
  }
  exports2.clear = clear;
  exports2.default = main;
  exports2.listUnistaller = listUnistaller;
  exports2.uninstall = uninstall;
  exports2.useContext = useContext;
  exports2.useModule = useModule;
  Object.defineProperty(exports2, "__esModule", { value: true });
  exports2[Symbol.toStringTag] = "Module";
});
//# sourceMappingURL=vue-module-loader.umd.js.map
